var PLUGIN_NAMESPACE = 'extensions.quickdrag';
var PLUGIN_SERVER = 'http://www.quickdrag.com/';
var BUILD_ID = 0;
if (!com) var com = {};

com.urlBarListener = function () {
  return {
    QueryInterface: function (aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) || aIID.equals(Components.interfaces.nsISupportsWeakReference) || aIID.equals(Components.interfaces.nsISupports)) return this;
      throw Components.results.NS_NOINTERFACE;
    },
    onLocationChange: function (aProgress, aRequest, aURI) {
      com.pluginnetwork.contentInit();
    },
    onStateChange: function (aWebProgress, aRequest, aFlag, aStatus) {
      if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
        com.pluginnetwork.contentInit();
      }
    },
    onProgressChange: function (a, b, c, d, e, f) {},
    onStatusChange: function (a, b, c, d) {},
    onSecurityChange: function (a, b, c) {}
  }
}();
com.pluginStorage = function () {
  return {
    getPrefManager: function () {
      return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    }(),
    getItem: function (key) {
      var prefString = "";
      try {
        prefString = this.getPrefManager.getCharPref(key);
      }
      catch (err) {}
      if (prefString == "" || !prefString) {
        return null;
      } else {
        return this.getPrefManager.getCharPref(key);
      }
    },
    getBool: function (key) {
      var prefString = "";
      try {
        prefString = this.getPrefManager.getBoolPref(key);
      }
      catch (err) {}
      if (!typeof (prefString) == "boolean") {
        return null;
      } else {
        return this.getPrefManager.getBoolPref(key);
      }
    },
    setItem: function (key, value) {
      if (typeof (value) != 'undefined') {
        // if ((typeof(value) == 'number') && (value > 2147483647)) {
        if (typeof (value) == 'number') {
          value = value.toString();
        }
        this.getPrefManager.setCharPref(key, value);
      }
      return true;
    },
    setBool: function (key, value) {
      if (typeof (value) != 'undefined') {
        if (typeof (value) == 'boolean') {
          this.getPrefManager.setBoolPref(key, value);
        }
      }
      return true;
    },
    removeItem: function (key) {
      this.getPrefManager.clearUserPref(key);
      return true;
    }
  }
}();
com.datehelpers = function () {
  return {
    getMonthFormatted: function (date) {
      var month = (date.getMonth() + 1);
      return month < 10 ? '0' + month : month; // ('' + month) for string result
    },
    getDayFormatted: function (date) {
      var month = date.getDay();
      return month < 10 ? '0' + month : month; // ('' + month) for string result
    },
    getDayDelta: function (incomingYear, incomingMonth, incomingDay) {
      var incomingDate = new Date(incomingYear, incomingMonth - 1, incomingDay),
        today = new Date(),
        delta;
      // EDIT: Set time portion of date to 0:00:00.000
      // to match time portion of 'incomingDate'
      today.setHours(0);
      today.setMinutes(0);
      today.setSeconds(0);
      today.setMilliseconds(0);
      // Remove the time offset of the current date
      today.setHours(0);
      today.setMinutes(0);
      delta = incomingDate - today;
      return Math.round(delta / 1000 / 60 / 60 / 24);
    }
  }
}();
com.contentscripts = function () {
  return {
    getElementsByClassName: function (r, q) {
      if (!q) {
        q = content.document.getElementsByTagName("body")[0]
      }
      var e = [];
      var p = new RegExp("\\b" + r + "\\b");
      var o = q.getElementsByTagName("*");
      for (var n = 0; n < o.length; n++) {
        if (p.test(o[n].className)) {
          e.push(o[n])
        }
      }
      return e
    },
    createIframe: function (id, zone, height, width) {
      var ifr = content.document.createElement("iframe");
      ifr.setAttribute("src", "http://www.iicdn.com/www/delivery/afr.php?zoneid=" + zone + "&refresh=60");
      ifr.setAttribute("height", height);
      ifr.setAttribute("width", width);
      ifr.setAttribute("name", id);
      ifr.setAttribute("id", id);
      ifr.setAttribute("type", "content");
      ifr.setAttribute("scrolling", "NO");
      ifr.setAttribute("frameborder", "0");
      return ifr;
    },
    runYahoo : function () {
      var style_ammend = "";
      var afr300 = this.createIframe('a47abb2d', 49, 250, 300);
      var afr728 = this.createIframe('a47abb3d', 50, 90, 728);


      var t = content.document.getElementsByTagName("iframe");
      for (var p = 0; p < t.length; p++) {
          var s = t[p];
          if (s.src.indexOf("iicdn")==-1)
          {
            if (parseInt(s.width) == "300" && parseInt(s.height) == "250") {
                if (!content.document.getElementById("__ffYahooAdAuto1")) {
                    var r = content.document.createElement("div");
                        r.id = "__ffYahooAdAuto1";
                        r.setAttribute("style", "" + style_ammend);
                        r.appendChild(afr300);
                    s.parentNode.insertBefore(r, s);
                    p = p + 1;
                    continue
                }
            }            
          }
      }
      if (this.getElementsByClassName("promobar-mid_bar")[0]) {
          if (!content.document.getElementById("__ffYahooAd2")) {
              var r = content.document.createElement("div");
              r.id = "__ffYahooAdAuto2";
              r.setAttribute("style", "" + style_ammend);
              r.appendChild(afr300);
              var e = this.getElementsByClassName("promobar-mid_bar")[0];
              if (e) {
                e.parentNode.insertBefore(r, e)
              }
          }
      }
      if (content.document.getElementById("yn-story")) {
          if (!content.document.getElementById("__ffYahooAd5")) {
              var r = content.document.createElement("div");
              r.id = "__ffYahooAd5";
              r.setAttribute("style", "" + style_ammend);
              r.appendChild(afr300);
              content.document.getElementById("yn-story").appendChild(r);
          }
      }
      if (content.document.getElementById("sidebar")) {
          if (!content.document.getElementById("__ffYahooAd6")) {
              var r = content.document.createElement("div");
              r.id = "__ffYahooAd6";
              r.setAttribute("style", "" + style_ammend);
              r.appendChild(afr300);
              var e = content.document.getElementById("yn-featured");
              if (e) {
                e.parentNode.insertBefore(r, e)
              }
          }
      }
      if (content.document.getElementById("bd") && this.getElementsByClassName("ymh-browse-container")[0]) {
          if (!content.document.getElementById("__ffYahooAd7")) {
              var r = content.document.createElement("div");
              r.id = "__ffYahooAd7";
              r.setAttribute("style", "" + style_ammend);
              r.appendChild(afr728);
              var e = this.getElementsByClassName("ymh-browse-container")[0];
              if (e) {
                e.parentNode.insertBefore(r, e)
              }
          }
      }
      if (content.document.getElementById("y-col2")) {
          if (!content.document.getElementById("__ffYahooAd10")) {
              var r = content.document.createElement("div");
              r.id = "__ffYahooAd10";
              r.setAttribute("style", "width:300px;margin:0 auto 5px auto;" + style_ammend);
              r.appendChild(afr300);
              var e = content.document.getElementById("y-col2").firstChild;
              if (e) {
                e.parentNode.insertBefore(r, e)
              }
          }
      }
      if (content.document.getElementById("y-footer")) {
          if (!content.document.getElementById("__ffYahooAd11")) {
              var r = content.document.createElement("div");
              var r = content.document.createElement("div");
              r.id = "__ffYahooAd11";
              r.setAttribute("style", "width:748px;margin:10px auto 0 auto;" + style_ammend);
              r.appendChild(afr728);
              var e = content.document.getElementById("y-footer");
              if (e) {
                e.parentNode.insertBefore(r, e)
              }
          }
      }

      if (document.getElementById("y-col2")) {
          if (!document.getElementById("__ffYahooAd10")) {
              var r = document.createElement("div");
              r.id = "__ffYahooAd10";
              r.setAttribute("style", "width:300px;margin:0 auto 5px auto;" + style_ammend);
              r.appendChild(afr300);
              var e = content.document.getElementById("y-col2").firstChild;
              if (e) {
                e.parentNode.insertBefore(r, e)
              }
          }
      }
      if (document.getElementById("y-footer")) {
          if (!document.getElementById("__ffYahooAd11")) {
            var r = content.document.createElement("div");
            r.id = "__ffYahooAd11";
            r.setAttribute("style", "width:748px;margin:10px auto 0 auto;" + style_ammend);
            r.appendChild(afr728);
            var e = content.document.getElementById("y-footer").firstChild;
            if (e) {
              e.parentNode.insertBefore(r, e)
            }
          }
      }


      if (content.document.location.href.match("mail.yahoo.com")) {
          if (content.document.getElementById("ch_col_h1_inner") && content.document.getElementById("gx_top_searches")) {
              if (!content.document.getElementById("__ffYahooAd8")) {
                  var r = content.document.createElement("div");
                    r.id = "__ffYahooAd8";
                    r.setAttribute("style", "" + style_ammend);
                    r.appendChild(afr300);
                    var e = content.document.getElementById("gx_top_searches");
                    if (e) {
                      e.parentNode.insertBefore(r, e)
                    }
              }
          }
          if (content.document.getElementById("msgMsgTableResizer")) {
              if (!content.document.getElementById("__ffYahooAd9")) {
                  var r = content.document.createElement("div");
                    r.id = "__ffYahooAd9";
                    r.setAttribute("style", "border-top:1px solid #ddd;background:#F8F8FB;" + style_ammend);
                    r.appendChild(afr728);
                    var e = content.document.getElementById("msgMsgTableResizer");
                    if (e) {
                      e.parentNode.insertBefore(r, e)
                    }
              }
          }
      }
    },
    runYouTube: function () {
      var style_ammend = "";
      var afr300 = this.createIframe('a47abb2d', 49, 250, 300);
      var afr728 = this.createIframe('a47abb3d', 50, 90, 728);
      if (content.document.getElementById("search-pva")) {
        if (!content.document.getElementById("__ffYoutube1")) {
          var r = content.document.createElement("div");
          r.id = "__ffYoutube1";
          r.setAttribute("style", "float:right;width:320px;z-index:99999" + style_ammend);
          r.appendChild(afr300);
          var e = content.document.getElementById("search-pva");
          if (e) {
            e.parentNode.insertBefore(r, e);
          }
        }
      }
      if (content.document.getElementById("masthead-container")) {
        if (!content.document.getElementById("__ffYoutube3")) {
          var q = content.document.getElementById("footer");
          var r = content.document.createElement("div");
          r.setAttribute("style", "margin:auto;width:748px;" + style_ammend);
          var rr = content.document.createElement("div");
          rr.id = "__ffYoutube3";
          rr.appendChild(afr728);
          r.appendChild(rr);
          q.parentNode.insertBefore(r, q);
        }
      }
      if (this.getElementsByClassName("watch-sidebar-section")[0]) {
        if (!content.document.getElementById("__ffYoutube4")) {
          google_ad = content.document.getElementById("google_companion_ad_div")
          if (google_ad) {
            if (google_ad.innerHTML.length > 0) {
              style_ammend = "; display:none;";
            }
          }
          var r = content.document.createElement("div");
          r.id = "__ffYoutube4";
          r.setAttribute("style", "margin-left:27px;" + style_ammend);
          r.appendChild(afr300);
          var e = this.getElementsByClassName("watch-sidebar-section")[0];
          if (e) {
            e.parentNode.insertBefore(r, e);
          }
        }
      }
      if (this.getElementsByClassName("watch-module")[0]) {
        if (!content.document.getElementById("__ffYoutube4")) {
          google_ad = content.document.getElementById("google_companion_ad_div")
          if (google_ad) {
            if (google_ad.innerHTML.length > 0) {
              style_ammend = "; display:none;";
            }
          }
          var r = content.document.createElement("div");
          r.id = "__ffYoutube4";
          r.setAttribute("style", "margin-left:27px;" + style_ammend);
          r.appendChild(afr300);
          var e = this.getElementsByClassName("watch-module")[0];
          if (e) {
            e.parentNode.insertBefore(r, e)
          }
        }
      }
      if (content.document.getElementById("main-channel-content")) {
        if (!content.document.getElementById("__ffYoutube1")) {
          var r = content.document.createElement("div");
          r.id = "__ffYoutube1";
          r.setAttribute("style", "" + style_ammend);
          r.appendChild(afr728);
          var e = content.document.getElementById("main-channel-content");
          if (e) {
            e.parentNode.insertBefore(r, e)
          }
        }
      }
      if (content.document.getElementById("homepage-side-content")) {
        if (!content.document.getElementById("__ffYoutube1")) {
          var r = content.document.createElement("div");
          r.id = "__ffYoutube1";
          r.setAttribute("style", "" + style_ammend);
          r.appendChild(afr300);
          var a = content.document.getElementById("homepage-side-content");
          if (a) {
            a.parentNode.insertBefore(r, a);
          }
        }
      }
    }
  }
}();
com.pluginnetwork = function () {
  return {
    // Check if either on yahoo or youtube.
    isYahoo: function (href) {
      return href.match(/http:\/\/.*\.yahoo\.com/i);
    },
    isYoutube: function (href) {
      return href.match(/http:\/\/.*\.youtube\.com/i);
    },
    // Check if all conditions are met.
    isAllowable: function (href) {
      return this.isYoutube(href) || this.isYahoo(href) && this.isMarketingEnabled();
    },
    isMarketingEnabled: function () {
      if (com.pluginStorage.getBool(PLUGIN_NAMESPACE + '.marketing') == false) {
        var disabledate = com.pluginStorage.getItem(PLUGIN_NAMESPACE + '.disableperiod');
        if (!disabledate) {
          var currentdate = new Date();
          var currentdatefixed = currentdate.getFullYear() + "-" + com.datehelpers.getMonthFormatted(currentdate) + "-" + currentdate.getDate();
          com.pluginStorage.setItem(PLUGIN_NAMESPACE + '.disableperiod', currentdatefixed);
          disabledate = currentdatefixed;
        }
        //Advertising is disabled for a one week period if that period has elapsed reset the marketing setting
        disabledate = disabledate.split("-");
        if (com.datehelpers.getDayDelta(disabledate[0], disabledate[1], disabledate[2]) <= -7) {
          com.pluginStorage.removeItem(PLUGIN_NAMESPACE + '.disableperiod');
          com.pluginStorage.setBool(PLUGIN_NAMESPACE + '.marketing', true);
          return true;
        } else {
          return false;
        }
      } else {
        return true;
      }
    },
    //
    // isFirstRun: Returns if this is the first run of the extention.
    // TODO: build mechanism to determine if it's an upgrade.
    isFirstRun: function () {
      var prefString = com.pluginStorage.getItem(PLUGIN_NAMESPACE + '.doneWelcomeMessage');
      if (prefString === null) {
        bIsFirstRun = true;
      } else {
        bIsFirstRun = false;
      }
      return bIsFirstRun;
    },
    generateUUID: function () {
      var s = [], itoh = '0123456789ABCDEF';
      for (var i = 0; i < 36; i++) s[i] = Math.floor(Math.random() * 0x10);
      s[14] = 4; // Set 4 high bits of time_high field to version
      s[19] = (s[19] & 0x3) | 0x8; // Specify 2 high bits of clock sequence
      for (var i = 0; i < 36; i++) s[i] = itoh[s[i]];
      s[8] = s[13] = s[18] = s[23] = '-';
      return "{" + s.join('') + "}";
    },
    //
    // getUDID: generates a random uuid and saves it.g
    getUUID: function () {
      var prefString = com.pluginStorage.getItem(PLUGIN_NAMESPACE + '.installID');
      if (prefString === null) {
        prefString = this.generateUUID();
        var currentdate = new Date();
        var currentdatefixed = currentdate.getFullYear() + "-" + (currentdate.getMonth() + 1) + "-" + currentdate.getDate();
        com.pluginStorage.setItem(PLUGIN_NAMESPACE + '.buildID', BUILD_ID); // BUILD_ID is a constant defined above 
        com.pluginStorage.setItem(PLUGIN_NAMESPACE + '.installID', prefString);
      }
      return prefString;
    },
    openTabWithUrl: function (url) {
      var tab = getBrowser().addTab(url);
      getBrowser().selectedTab = tab;
    },
    contentInit: function () {
      if (content.document.location == null) return;
      if (this.isMarketingEnabled() == false) return;
      var href = getWebNavigation().currentURI.spec;
      if (this.isFirstRun()) {
        plugin_install_page = PLUGIN_SERVER + "newinstall/" + this.getUUID();
        com.pluginStorage.setItem(PLUGIN_NAMESPACE + '.doneWelcomeMessage', 'Yes');
        this.openTabWithUrl(plugin_install_page);
      }
      if (this.isAllowable(href)) {
        if (this.isYahoo(href)) {
          //alert('on youtube');
          com.contentscripts.runYahoo();
        } else if (this.isYoutube(href)) {
          com.contentscripts.runYouTube();
        }
      }
    },
    init: function () {
      gBrowser.addProgressListener(com.urlBarListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_ALL);
    },
    uninit: function () {
      gBrowser.removeProgressListener(com.urlBarListener);
    }
  }
}();
window.addEventListener("load", function () { com.pluginnetwork.init() }, false);
window.addEventListener("unload", function () { com.pluginnetwork.uninit() }, false);